#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include "semun.c"
int main(int argc, char *argv[])
{
  /* IPC */
  pid_t pid;
  key_t key;
  int semid;
  union semun arg;
  struct sembuf lock_res = {0, -1, 0};
  struct sembuf rel_res = {0, 1, 0};
  struct sembuf push[2] = {{1, -1, IPC_NOWAIT}, {2, 1, IPC_NOWAIT}};
  struct sembuf pop[2] = {{1, 1, IPC_NOWAIT}, {2, -1, IPC_NOWAIT}};
/*  */
  int i;
if(argc < 2){
    printf("Usage: bufdemo [dimensione]\n");
    exit(0);
  }
/*  */
  key = ftok("/etc/fstab", getpid());
/*      */
  semid = semget(key, 3, 0666 | IPC_CREAT);
/*    0 ( )  "1"*/
  arg.val = 1;
  semctl(semid, 0, SETVAL, arg);
/*     1 (  )
        */
  arg.val = atol(argv[1]);
  semctl(semid, 1, SETVAL, arg);
/*     2 (   )  "0" */
  arg.val = 0;
  semctl(semid, 2, SETVAL, arg);
/* Fork */
  for (i = 0; i < 5; i++){
    pid = fork();
    if (!pid){
      for (i = 0; i < 20; i++){
	sleep(rand()%6);
	/*    (  0) */
	if (semop(semid, &lock_res, 1) == -1){
	  perror("semop:lock_res");
	}
	/*    (  1) /
	     (  2) */
	if (semop(semid, push, 2) != -1){
	  printf("---> Process:%d\n", getpid());
	}
	else{
	  printf("---> Process:%d  BUFFER FULL\n", getpid());
	}
	/*   */
	semop(semid, &rel_res, 1);
      }
      exit(0);
    }
  }
for (i = 0;i < 10; i++){
    sleep(rand()%3);
    /*    (  0)*/
    if (semop(semid, &lock_res, 1) == -1){
      perror("semop:lock_res");
    }
    /*    (  1) /
         (  2) */
    if (semop(semid, pop, 2) != -1){
      printf("<--- Process:%d\n", getpid());
    }
    else printf("<--- Process:%d  BUFFER EMPTY\n", getpid());
    /*   */
    semop(semid, &rel_res, 1);
  }
/*   */
  semctl(semid, 0, IPC_RMID);
return 0;
}
